<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.1) on Sat Oct 05 11:12:57 CEST 2019 -->
<title>DatabaseReader (dblp.datatools 2019.08.0.0 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-10-05">
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DatabaseReader (dblp.datatools 2019.08.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":9,"i1":9,"i2":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">bous.philipp.dblp.datatools.db.reader</a></div>
<h2 title="Class DatabaseReader" class="title">Class DatabaseReader</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>bous.philipp.dblp.datatools.db.reader.DatabaseReader</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">DatabaseReader</span>
extends java.lang.Object</pre>
<div class="block">Provides convenience methods to draw records from a database while converting them back to
 <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">DatabaseReader</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static <a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,int,int,bous.philipp.dblp.datatools.datamodel.CsClassification,boolean)">selectRecordsFromDB</a></span>&#8203;(java.sql.Connection&nbsp;connection,
                   java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                   java.lang.String&nbsp;recordTableName,
                   java.lang.String&nbsp;featureTableName,
                   int&nbsp;startingId,
                   int&nbsp;maxNumber,
                   <a href="../../datamodel/CsClassification.html" title="enum in bous.philipp.dblp.datatools.datamodel">CsClassification</a>&nbsp;classificationConstraint,
                   boolean&nbsp;byRandomId)</code></th>
<td class="colLast">
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static <a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,int,bous.philipp.dblp.datatools.datamodel.CsClassification,boolean)">selectRecordsFromDB</a></span>&#8203;(java.sql.Connection&nbsp;connection,
                   java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                   java.lang.String&nbsp;recordTableName,
                   java.lang.String&nbsp;featureTableName,
                   int&nbsp;maxNumber,
                   <a href="../../datamodel/CsClassification.html" title="enum in bous.philipp.dblp.datatools.datamodel">CsClassification</a>&nbsp;classificationConstraint,
                   boolean&nbsp;byRandomId)</code></th>
<td class="colLast">
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>static <a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,java.lang.String,java.lang.String,boolean)">selectRecordsFromDB</a></span>&#8203;(java.sql.Connection&nbsp;connection,
                   java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                   java.lang.String&nbsp;recordTableName,
                   java.lang.String&nbsp;featureTableName,
                   java.lang.String&nbsp;whereClauseRecords,
                   java.lang.String&nbsp;limitClauseRecords,
                   boolean&nbsp;byRandomId)</code></th>
<td class="colLast">
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DatabaseReader</h4>
<pre>public&nbsp;DatabaseReader()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,java.lang.String,java.lang.String,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectRecordsFromDB</h4>
<pre class="methodSignature">public static&nbsp;<a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a>&nbsp;selectRecordsFromDB&#8203;(java.sql.Connection&nbsp;connection,
                                                  java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                                                  java.lang.String&nbsp;recordTableName,
                                                  java.lang.String&nbsp;featureTableName,
                                                  java.lang.String&nbsp;whereClauseRecords,
                                                  java.lang.String&nbsp;limitClauseRecords,
                                                  boolean&nbsp;byRandomId)</pre>
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.
 Lets the user specify a where and limit-clause to constraint which records are drawn, so this method
 is suitable to "cut out" sections of records if needed (f.e. useful for some CV-tasks).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connection</code> - database connection</dd>
<dd><code>excludedFeatures</code> - exclude those featuretypes from the record-document-instantiation (to conveniently keep them simple if not the full information is needed)</dd>
<dd><code>recordTableName</code> - name of the record table</dd>
<dd><code>featureTableName</code> - name of the corresponding feature-table</dd>
<dd><code>whereClauseRecords</code> - where-clause to contraint the selection of records (including the "WHERE"-keyword)</dd>
<dd><code>limitClauseRecords</code> - limit-clause to constraint the selection of records (including the "LIMIT"-keyword)</dd>
<dd><code>byRandomId</code> - exists for compatibility-reasons; if true; the method will expect the db-tables to contain a column "random_id" and will draw records sorted by random_id instead of id; useful if "normal" ids are connected to some form of structural ordering</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the record documents as list</dd>
</dl>
</li>
</ul>
<a id="selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,int,int,bous.philipp.dblp.datatools.datamodel.CsClassification,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectRecordsFromDB</h4>
<pre class="methodSignature">public static&nbsp;<a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a>&nbsp;selectRecordsFromDB&#8203;(java.sql.Connection&nbsp;connection,
                                                  java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                                                  java.lang.String&nbsp;recordTableName,
                                                  java.lang.String&nbsp;featureTableName,
                                                  int&nbsp;startingId,
                                                  int&nbsp;maxNumber,
                                                  <a href="../../datamodel/CsClassification.html" title="enum in bous.philipp.dblp.datatools.datamodel">CsClassification</a>&nbsp;classificationConstraint,
                                                  boolean&nbsp;byRandomId)</pre>
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.
 Provides a parameter to specify at which id to start reading subsequently.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connection</code> - database connection</dd>
<dd><code>excludedFeatures</code> - exclude those featuretypes from the record-document-instantiation (to conveniently keep them simple if not the full information is needed)</dd>
<dd><code>recordTableName</code> - name of the record table</dd>
<dd><code>featureTableName</code> - name of the corresponding feature-table</dd>
<dd><code>startingId</code> - id of the first record that should be read, going upwards after that (enables basic split processing of individual parts of a database; remark to maintain good shuffling BEFORE assigning ids to records)</dd>
<dd><code>maxNumber</code> - maximum number of records to be drawn, -1 for all</dd>
<dd><code>classificationConstraint</code> - specifies constraints on the class label of records to be considered</dd>
<dd><code>byRandomId</code> - exists for compatibility-reasons; if true; the method will expect the db-tables to contain a column "random_id" and will draw records sorted by random_id instead of id; useful if "normal" ids are connected to some form of structural ordering</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the record documents as list</dd>
</dl>
</li>
</ul>
<a id="selectRecordsFromDB(java.sql.Connection,java.util.EnumSet,java.lang.String,java.lang.String,int,bous.philipp.dblp.datatools.datamodel.CsClassification,boolean)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>selectRecordsFromDB</h4>
<pre class="methodSignature">public static&nbsp;<a href="SelectionResult.html" title="class in bous.philipp.dblp.datatools.db.reader">SelectionResult</a>&nbsp;selectRecordsFromDB&#8203;(java.sql.Connection&nbsp;connection,
                                                  java.util.EnumSet&lt;<a href="../../datamodel/FeatureType.html" title="enum in bous.philipp.dblp.datatools.datamodel">FeatureType</a>&gt;&nbsp;excludedFeatures,
                                                  java.lang.String&nbsp;recordTableName,
                                                  java.lang.String&nbsp;featureTableName,
                                                  int&nbsp;maxNumber,
                                                  <a href="../../datamodel/CsClassification.html" title="enum in bous.philipp.dblp.datatools.datamodel">CsClassification</a>&nbsp;classificationConstraint,
                                                  boolean&nbsp;byRandomId)</pre>
<div class="block">Draws records from a database and returns them in form of a list of <a href="../../datamodel/RecordDocument.html" title="class in bous.philipp.dblp.datatools.datamodel"><code>RecordDocument</code></a>s.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connection</code> - database connection</dd>
<dd><code>excludedFeatures</code> - exclude those featuretypes from the record-document-instantiation (to conveniently keep them simple if not the full information is needed)</dd>
<dd><code>recordTableName</code> - name of the record table</dd>
<dd><code>featureTableName</code> - name of the corresponding feature-table</dd>
<dd><code>maxNumber</code> - maximum number of records to be drawn, -1 for all</dd>
<dd><code>classificationConstraint</code> - specifies constraints on the class label of records to be considered</dd>
<dd><code>byRandomId</code> - exists for compatibility-reasons; if true; the method will expect the db-tables to contain a column "random_id" and will draw records sorted by random_id instead of id; useful if "normal" ids are connected to some form of structural ordering</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the record documents as list</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
